USE [StairwayToSQLCLR]

SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO

------------

EXEC StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestProc
	@Query =  N'SELECT Tab.Num, 44 AS [OtherNum] FROM (VALUES (1),(23),(3423)) Tab(Num)',
	@PrintFieldCount = 1


EXEC StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestProc 'SELECT * FROM StairwayToSQLCLR.sys.columns' -- No field count in Messages tab
EXEC StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestProc 'SELECT * FROM StairwayToSQLCLR.sys.columns', 1 -- field count in Messages tab

EXEC StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestProc 'SELECT * FROM sys.columnsd' -- error
EXEC StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestProc 'SgELECT * FROM sys.columns' -- error

------------

SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 0, 0)
-- error: "Invalid @CountMethod value: 0"
SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 1, 0)
-- error: "This statement has attempted to access data whose access is restricted by the assembly"
SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 2, 0)
-- woo hoo!!
SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02222', 2, 0)
-- error: "Invalid object name 'StairwayToSQLCLR_02222'"


SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 3, 0)
-- error: "This statement has attempted to access data whose access is restricted by the assembly"
SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 4, 0)
-- error: "Invalid use of a side-effecting operator 'EXECUTE STRING' within a function"
SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 5, 0)
-- woo hoo!
SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 6, 0)
-- error: "Invalid use of a side-effecting operator 'SET ON/OFF' within a function"
SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 7, 0)
-- error: "Invalid use of a side-effecting operator 'ASSIGN' within a function"


-- run the following 2 statements once to set up for @CountMethod = 8
CREATE TABLE #Temp (Col1 INT)
INSERT INTO #Temp (Col1) VALUES (123), (3423432), (23)

SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 8, 0)
-- 3

INSERT INTO #Temp (Col1) VALUES (4), (5), (6), (7)
SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 8, 0)
-- 7



-- CONTEXT_INFO() will return NULL if never set, but cannot be set to NULL
SELECT CONTEXT_INFO()

SET CONTEXT_INFO 0x00
SELECT CONTEXT_INFO()
SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 9, 0)
-- 0

SET CONTEXT_INFO 0x02223344
SELECT CONTEXT_INFO() -- 0x0222334400000000000000...
SELECT CONVERT(VARBINARY(5), CONTEXT_INFO()) -- 0x0222334400
SELECT CONVERT(BIGINT, CONVERT(VARBINARY(5), CONTEXT_INFO())) -- 9163719680
SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 9, 0)
-- 9163719680


SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 10, 0)
-- error: "Invalid use of a side-effecting operator 'RAISERROR' within a function"




-- Controls (they should run either without error, or with the expected error)
EXEC StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_GetNumRows N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 3
EXEC StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_GetNumRows N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 4
EXEC StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_GetNumRows N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 6
EXEC StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_GetNumRows N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 7
-- All four of the above return: 100

EXEC StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_GetNumRows N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 8
-- 7

EXEC StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_GetNumRows N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 9
-- 9163719680

EXEC StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_GetNumRows N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 10
-- error: @CountMethod needs to be between 3 and 9.

------------

--USE [StairwayToSQLCLR]; ALTER ASSEMBLY [StairwayToSQLCLR-02-Example] WITH PERMISSION_SET = SAFE;
-- Attempt to insert a row via @InsertRow = 1
SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 2, 1) AS [RowCount]

-- Allow External Access for external / regular DB connection
ALTER DATABASE [StairwayToSQLCLR] SET TRUSTWORTHY ON;
USE [StairwayToSQLCLR]; ALTER ASSEMBLY [StairwayToSQLCLR-02-Example] WITH PERMISSION_SET = EXTERNAL_ACCESS;

-- Attempt to insert a row via @InsertRow = 1
SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 2, 1) AS [RowCount]
-- row is inserted, but row count returned was taken before the INSERT

-- display new row count ; no new INSERT
SELECT StairwayToSQLCLR.dbo.StairwayToSQLCLR_02_TestFunc(N'StairwayToSQLCLR.dbo.StairwayToSQLCLR_02', 2, 0) AS [RowCount]

-- display effect of using @InsertRow = 1
SELECT * FROM dbo.StairwayToSQLCLR_02 ORDER BY InsertTime DESC

GO
-------------------------------------
